#typedef HFONT int
#typedef COLORREF int
#typedef HDC int
#typedef HBRUSH int
#typedef HWND int
#typedef HGDIOBJ int
#typedef SIZE_T int
#typedef HRGN int
#typedef HBITMAP int
#typedef HANDLE int
#typedef WPARAM int
#typedef LPARAM int
#typedef LRESULT int
#typedef WNDPROC int
#typedef HINSTANCE int
#typedef HCURSOR int

// align all functions to dword
#asm
%macro .ef 0
	align 4
	.ef
%endm
#endasm


struct SCROLLINFO
{
    UINT    cbSize;
    UINT    fMask;
    int     nMin;
    int     nMax;
    UINT    nPage;
    int     nPos;
    int     nTrackPos;
}
struct PAINTSTRUCT {
    HDC         hdc;
    BOOL        fErase;
    RECT        rcPaint;
    BOOL        fRestore;
    BOOL        fIncUpdate;
    unsigned byte rgbReserved[32];
}

struct SIZE {
    LONG        cx;
    LONG        cy;
}

struct MEMORY_BASIC_INFORMATION {
    VOID *BaseAddress;
    VOID *AllocationBase;
    DWORD AllocationProtect;
    SIZE_T RegionSize;
    DWORD State;
    DWORD Protect;
    DWORD Type;
}

struct TEXTMETRIC { 
  LONG tmHeight; 
  LONG tmAscent; 
  LONG tmDescent; 
  LONG tmInternalLeading; 
  LONG tmExternalLeading; 
  LONG tmAveCharWidth; 
  LONG tmMaxCharWidth; 
  LONG tmWeight; 
  LONG tmOverhang; 
  LONG tmDigitizedAspectX; 
  LONG tmDigitizedAspectY; 
  byte tmFirstChar; 
  byte tmLastChar; 
  byte tmDefaultChar; 
  byte tmBreakChar; 
  BYTE tmItalic; 
  BYTE tmUnderlined; 
  BYTE tmStruckOut; 
  BYTE tmPitchAndFamily; 
  BYTE tmCharSet; 
}

declare import, GetTextMetrics alias GetTextMetricsA(HDC hdc,TEXTMETRIC *lptm),BOOL;
declare import,SetRectEmpty(RECT *lprc),BOOL;
declare import,CopyRect(RECT *lprcDst,RECT *lprcSrc),BOOL;
declare import, SetBkColor(HDC hdc, COLORREF color),COLORREF;
declare import,GetSysColor(int nIndex),DWORD;
declare import, SetTextColor(HDC hdc, COLORREF color),COLORREF;
declare import,GetClientRect(HWND hWnd, RECT *lpRect),BOOL;
declare import,ZeroMemory alias RtlZeroMemory(void* Destination,int Length);
declare import,GetDC(HWND hWnd),HDC;
declare import, DeleteObject(HGDIOBJ ho),BOOL;
declare import, DeleteDC(HDC hdc),BOOL;
declare import, SelectObject(HDC hdc, HGDIOBJ h),HGDIOBJ;
declare import,ReleaseDC(HWND hWnd,HDC hDC),int;
declare import,BeginPaint(HWND hWnd, PAINTSTRUCT *lpPaint),HDC;
declare import,EndPaint(HWND hWnd,PAINTSTRUCT *lpPaint),BOOL;
declare import,SetScrollInfo(HWND hwnd,int nBar,SCROLLINFO *lpsi,BOOL redraw),int;
declare import,GetScrollInfo(HWND hwnd,int nBar,SCROLLINFO *lpsi),int;
declare import,IsWindowVisible(HWND hWnd),BOOL;
declare import,FillRect(HDC hDC,RECT *lprc, HBRUSH hbr),int;
declare import,SetRect(RECT *lprc,int xLeft,int yTop,int xRight,int yBottom),BOOL;
declare import,DrawText alias DrawTextA(HDC hdc, string* lpchText,int cchText,RECT *lprc,UINT format),int;
declare import,GetTextExtentPoint32 alias GetTextExtentPoint32A(HDC hdc,string* lpString,int c,SIZE * psizl),BOOL;
declare import, CreateSolidBrush(COLORREF color),HBRUSH;
declare import,VirtualAlloc(void* lpAddress,SIZE_T dwSize,DWORD flAllocationType,DWORD flProtect),void*;
declare import,VirtualQuery(void* lpAddress,MEMORY_BASIC_INFORMATION *lpBuffer,SIZE_T dwLength),SIZE_T; 
declare import,MoveMemory alias RtlMoveMemory(void* Destination,void* Source,SIZE_T Length); 
declare import,VirtualFree(void* lpAddress,SIZE_T dwSize,DWORD dwFreeType),BOOL;
declare import,lstrlen alias lstrlenA(string* lpString),int;
declare import, GetStockObject(int i),HGDIOBJ; 
declare import, SetScrollPos(HWND hWnd,int nBar,int nPos,BOOL bRedraw),int;
declare import, GetScrollPos(HWND hWnd, int nBar),int;
declare import,SystemParametersInfo alias SystemParametersInfoA(UINT uiAction,UINT uiParam,void *pvParam,UINT fWinIni),BOOL; 
import int cdecl strnicmp alias _strnicmp(...);
declare import,ScrollDC(HDC hDC,int dx,int dy,RECT *lprcScroll,RECT *lprcClip,HRGN hrgnUpdate,RECT *lprcUpdate),BOOL;
declare import, SetWindowLong alias SetWindowLongA(HWND hWnd,int nIndex,LONG dwNewLong),LONG;
declare import, TabbedTextOut alias TabbedTextOutA(HDC hDC,int X,int Y,string* lpString, int nCount,int nTabPositions,INT *lpnTabStopPositions,int nTabOrigin),LONG;
declare import, ExtTextOut alias ExtTextOutA(HDC hdc, int X, int Y, UINT fuOptions, RECT* lprc, string *lpString, UINT cbCount, INT* lpDx),BOOL;
declare import, TextOut alias TextOutA(HDC hdc, int nXStart, int nYStart, string *lpString, int cbString),BOOL;
declare import, CreateCompatibleDC(HDC hdc),HDC;
declare import, CreateCompatibleBitmap(HDC hdc, int cx, int cy),HBITMAP;
declare import, BitBlt(HDC hdc, int x, int y, int cx, int cy, HDC hdcSrc, int x1, int y1, DWORD rop),BOOL;
declare import, ShellExecute alias ShellExecuteA(HWND hwnd,string* lpOperation,string* lpFile,string* lpParameters,string* lpDirectory,INT nShowCmd),HINSTANCE;
declare import, CreateCaret(HWND hWnd,HBITMAP hBitmap,int nWidth,int nHeight),BOOL;
declare import, ShowCaret(HWND hWnd),BOOL;
declare import, HideCaret(HWND hWnd),BOOL;
declare import, DestroyCaret(),BOOL;
declare import, SetCaretPos(int x,int y),BOOL;
declare import, GetCaretPos(POINT *pt),BOOL;
declare import, GetTabbedTextExtent alias GetTabbedTextExtentA(HDC hDC,string *lpString, int nCount,int nTabPositions,INT *lpnTabStopPositions),DWORD;
declare import, MessageBeep(int x);
declare import,GetFocus(),HWND;
declare import,PtInRect(RECT *lprc,POINT pt byval),BOOL;
declare import,SetProp alias SetPropA(HWND hWnd,string * lpString, HANDLE hData),BOOL;
declare import,GetProp alias GetPropA(HWND hWnd,string * lpString),HANDLE;
declare import,CallWindowProc alias CallWindowProcA(WNDPROC lpPrevWndFunc,HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam),LRESULT;
declare import, GetTextExtentExPoint alias GetTextExtentExPointA(HDC hdc,string *lpszStr,int cchString,int nMaxExtent,INT *lpnFit, INT *alpDx,SIZE *lpSize),BOOL;
declare import, LoadCursor alias LoadCursorA(HINSTANCE hInstance, string *lpCursorName),HCURSOR;
declare import, SetCapture(HWND hWnd),HWND;
declare import, ReleaseCapture(),BOOL;
declare import, SetCursor(HCURSOR hCursor),HCURSOR;
#define WM_SETFONT                      0x0030
#define WM_MOUSEWHEEL                   0x020A
#define WM_MOUSEACTIVATE 0x21
#define WM_KILLFOCUS 8
#define WM_KEYDOWN 0x100
#define WM_SETTEXT 0x000C
#define WM_SETCURSOR 0x20

//////////////////////////////////////////////
// implemented edit messages

#define EM_GETSEL               0x00B0
#define EM_SETSEL               0x00B1
#define EM_GETRECT              0x00B2
//#define EM_SETRECT              0x00B3
/*
#define EM_SETRECTNP            0x00B4
#define EM_SCROLL               0x00B5
#define EM_LINESCROLL           0x00B6
#define EM_SCROLLCARET          0x00B7
#define EM_GETMODIFY            0x00B8
#define EM_SETMODIFY            0x00B9
#define EM_GETLINECOUNT         0x00BA
#define EM_LINEINDEX            0x00BB
#define EM_SETHANDLE            0x00BC
#define EM_GETHANDLE            0x00BD
#define EM_GETTHUMB             0x00BE
#define EM_LINELENGTH           0x00C1
#define EM_REPLACESEL           0x00C2
#define EM_GETLINE              0x00C4
#define EM_LIMITTEXT            0x00C5
#define EM_CANUNDO              0x00C6
#define EM_UNDO                 0x00C7
#define EM_FMTLINES             0x00C8
#define EM_LINEFROMCHAR         0x00C9
#define EM_SETTABSTOPS          0x00CB
#define EM_SETPASSWORDCHAR      0x00CC
#define EM_EMPTYUNDOBUFFER      0x00CD
#define EM_GETFIRSTVISIBLELINE  0x00CE
#define EM_SETREADONLY          0x00CF
#define EM_SETWORDBREAKPROC     0x00D0
#define EM_GETWORDBREAKPROC     0x00D1
#define EM_GETPASSWORDCHAR      0x00D2
#define EM_SETMARGINS           0x00D3
#define EM_GETMARGINS           0x00D4
#define EM_SETLIMITTEXT         EM_LIMITTEXT
#define EM_GETLIMITTEXT         0x00D5
#define EM_POSFROMCHAR          0x00D6
#define EM_CHARFROMPOS          0x00D7
#define EM_SETIMESTATUS         0x00D8*/
#define EM_GETIMESTATUS         0x00D9



#define SPI_GETWHEELSCROLLLINES    0x0068
#define COLOR_WINDOW            5
#define COLOR_WINDOWTEXT        8
#define COLOR_HIGHLIGHTTEXT     14
#define ETO_CLIPPED 4
#define SB_HORZ             0
#define SB_VERT             1
#define SRCCOPY             0x00CC0020
#define VK_PRIOR 0x21
#define VK_NEXT  0x22
#define VK_HOME  0x24
#define VK_END   0x23
#define VK_DOWN  0x28
#define VK_UP    0x26
#define VK_LEFT           0x25
#define VK_RIGHT          0x27
#define VK_DOWN           0x28 
#define SIF_RANGE           0x0001
#define SIF_PAGE            0x0002
#define SIF_POS             0x0004
#define SIF_DISABLENOSCROLL 0x0008
#define SIF_TRACKPOS        0x0010
#define SIF_ALL             (SIF_RANGE | SIF_PAGE | SIF_POS | SIF_TRACKPOS)
#define GWL_ID -12;
#define GWL_WNDPROC         (-4)
#define WM_SETFOCUS         7
#define MEM_COMMIT           0x1000
#define PAGE_READWRITE         0x04
#define MEM_RELEASE          0x8000
#define DT_TOP                      0x00000000
#define DT_LEFT                     0x00000000
#define DT_CENTER                   0x00000001
#define DT_RIGHT                    0x00000002
#define DT_VCENTER                  0x00000004
#define DT_BOTTOM                   0x00000008
#define DT_WORDBREAK                0x00000010
#define DT_SINGLELINE               0x00000020
#define DT_EXPANDTABS               0x00000040
#define DT_TABSTOP                  0x00000080
#define DT_NOCLIP                   0x00000100
#define DT_EXTERNALLEADING          0x00000200
#define DT_CALCRECT                 0x00000400
#define DT_NOPREFIX                 0x00000800
#define DT_INTERNAL                 0x00001000

#define DT_EDITCONTROL              0x00002000
#define DT_PATH_ELLIPSIS            0x00004000
#define DT_END_ELLIPSIS             0x00008000
#define DT_MODIFYSTRING             0x00010000
#define DT_RTLREADING               0x00020000
#define DT_WORD_ELLIPSIS            0x00040000
#define DT_NOFULLWIDTHCHARBREAK     0x00080000
#define DT_HIDEPREFIX               0x00100000
#define DT_PREFIXONLY               0x00200000 
#define DEFAULT_GUI_FONT    17

